/**
 * PilrcEdit - a graphical editor for PilRC files.
 * Copyright (C) 2000 Rob Nielsen
 * rnielsen@wn.com.au
 * http://www.wn.com.au/rnielsen/
 *
 * Released under the GNU GPL - http://www.gnu.org/copyleft/gpl.html
 */
package pilrcedit;

public class IDExpression extends Expression
{
  public static final int AUTOID=0;
  public static final int ID=1;
  private boolean autoid;

  public IDExpression()
  {
    autoid=true;
  }

  public IDExpression(String s)
  {
	  super(s);
	}

  public boolean isAutoID()
  {
		return autoid;
	}

  public boolean isAbsolute()
  {
		if (autoid)
		  return false;
		return super.isAbsolute();
	}

  public String getExpression()
  {
		if (autoid)
		  return Keywords.get(this,AUTOID);
		return super.getExpression();
	}

  public void setExpression(String s)
  {
		autoid=(Keywords.get(this,s)==AUTOID||s==null||s.length()==0);
		if (autoid)
		  s=null;
		super.setExpression(s);
	}

	public void setValue(int i)
	{
		autoid=false;
		super.setValue(i);
	}

  public String toOutputString()
  {
    if (autoid)
      return " "+Keywords.get(this,AUTOID);
    else
      return " "+Keywords.get(this,ID)+" "+getExpression();
  }
}
